//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
// original idea fr this indicator by Dan Valcu
//------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DimGray
#property indicator_color2 PaleVioletRed
#property indicator_width1 1
#property indicator_width2 2
#property indicator_level1 0

//
//
//
//
//

extern string TimeFrame     = "Current time frame";
extern bool   BetterFormula = false;
extern int    SignalPeriod  = 3;
extern int    SignalMethod  = MODE_SMA;

double bhaOpn[];
double bhaClo[];
double haDelta[];
double haSignal[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(6);
   IndicatorBuffers(4);
   SetIndexBuffer(0, haDelta);
   SetIndexBuffer(1, haSignal);
   SetIndexBuffer(2, bhaOpn);
   SetIndexBuffer(3, bhaClo);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" haDelta ("+SignalPeriod+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { haDelta[0] = MathMin(limit+1,Bars-1); return(0); }
          
   //
   //
   //
   //
   //
   
   if (timeFrame == Period())
   {
      for (int i=limit; i >= 0; i--)
      {
         double prOpen  = Open[i];
         double prClose = Close[i];
         double prLow   = Low[i];
         double prHigh  = High[i];

         if (BetterFormula) {
               if (prHigh!=prLow)
                     double haClose = (prOpen+prClose)/2.0+(((prClose-prOpen)/(prHigh-prLow))*MathAbs((prClose-prOpen)/2.0));
                     else   haClose = (prOpen+prClose)/2.0; }
          else              haClose = (prOpen+prHigh+prLow+prClose)/4;
                     double haOpen  = (bhaOpn[i+1]+bhaClo[i+1])/2.0;

         //
         //
         //
         //
         //
         
         bhaOpn[i]  = haOpen;
         bhaClo[i]  = haClose;
         haDelta[i] = haClose-haOpen;
      }
      for (i=limit; i >= 0; i--) haSignal[i] = iMAOnArray(haDelta,0,SignalPeriod,0,SignalMethod,i);
      return(0);
   }
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         haDelta[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BetterFormula,SignalPeriod,SignalMethod,0,y);
         haSignal[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",BetterFormula,SignalPeriod,SignalMethod,1,y);
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}